<template>
  <transition name="fade-slide">
    <div class="app-drawer-container" v-if="show">
      <div class="app-drawer">
        <b-icon-x class="app-drawer-close" v-on:click="closeAppDrawer" />

        <div class="app-drawer-content">
          <h2>{{ organization.name }}</h2>
          
          <AppDrawerHeader>
            Your Apps
          </AppDrawerHeader>

          <AppDrawerLink text='Issues' icon='Kanban' link='/issues' />
          <AppDrawerLink text='Documentation' icon='FileText' link='/docs' />
          <AppDrawerLink text='Source Control' icon='CodeSlash' link='/code' />
          <AppDrawerLink text='Pipelines' icon='Window' link='/pipelines' />
          <AppDrawerLink text='Artifacts' icon='Archive' link='/artifacts' />
          <AppDrawerLink text='Security' icon='ShieldShaded' link='/security' />
          <AppDrawerLink text='Organization' icon='Building' link='/organization' />

          <AppDrawerHeader>
            Recent
          </AppDrawerHeader>

          <AppDrawerLink text='Test' subtext='Workflow project' icon='Kanban' link='/issues/TEST' />
          <AppDrawerLink text='Web UI Framework' subtext='Source control' icon='CodeSlash' link='/code/test-repo' />
          <AppDrawerLink text='Code Indexer' subtext='Artifacts - Docker' icon='Archive' link='/artifacts/code-indexer' />
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
import { mapState } from 'vuex'
import AppDrawerHeader from '@/components/AppDrawerHeader.vue'
import AppDrawerLink from '@/components/AppDrawerLink.vue'
import { BIcon, BIconX, BIconWindow, BIconFileText, BIconCodeSlash, BIconArchive, BIconShieldShaded, BIconBuilding, BIconKanban } from 'bootstrap-vue'

export default {
  name: 'AppDrawer',
  props: {
    show: Boolean
  },
  computed: mapState({
    organization: state => state.organization.info
  }),
  components: {
    AppDrawerHeader,
    AppDrawerLink,
    BIcon,
    BIconX
  },
  methods: {
    closeAppDrawer() {
      // this.show = false;
      this.$emit('close');
    }
  }
}
</script>

<style scoped lang="scss">
$drawer-width: 350px;

.fade-slide-enter, .fade-slide-leave-to {
  opacity: 0;

  & > .app-drawer {
    transition: all 420ms cubic-bezier(0.2, 0, 0, 1) 0s;
    transform: translateX(-$drawer-width);
  }
}
.fade-slide-enter-to, .fade-slide-leave {
  opacity: 1;

  & > .app-drawer {
    transition: all 420ms cubic-bezier(0.2, 0, 0, 1) 0s;
    transform: translateX(0);
  }
}
.fade-slide-enter-active, .fade-slide-leave-active {
  transition: all 420ms cubic-bezier(0.2, 0, 0, 1) 0s
}

.app-drawer-container {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: #0000008f;
  z-index: 99999;

  .app-drawer {
    position: absolute;
    top: 0;
    left: 0;
    width: $drawer-width;
    height: 100%;
    background: white;
    overflow: hidden;
    display: flex;
    color: #444444;
    background-color: #fbfbfb;

    .app-drawer-close {
      cursor: pointer;
      margin: 20px 15px 0 20px;
      font-size: 1.7rem;
    }
    .app-drawer-content {
      margin-top: 15px;
    }
  }
}
</style>
